SuperStrict
Framework BRL.StandardIO
Import BRL.LinkedList

Const CHECKPERMUTATIONS:Int=False
Const SHOWCOMBINATIONS:Int=False

Local toPay:Int = Int(Input("Betrag in Cent: "))
Local coins:Int[] = New Int[4]
Local coinVals:Int[] = [1,2,5,10]
For Local i:Int = 0 To 3
	coins[i] = Int(Input("Anzahl "+coinVals[i]+"ct Muenzen: "))
Next
Print("Kombinationen: "+getPaymentCombos(toPay,coins,coinVals,-1,New Int[coins.length],New TList))

Function getPaymentCombos:Int(toPay:Int, coins:Int[], coinVals:Int[], pay:Int, currentSolution:Int[], allSolutions:TList)
	'DebugStop
	If (pay>=0) Then
		toPay :- coinVals[pay]
		coins[pay] :- 1
		currentSolution[pay] :+ 1
	EndIf
	Local totalCoins:Int=0
	For Local i:Int = 0 To coins.length-1
		If (coins[i]<0) Then Return 0
		totalCoins :+ coins[i]
	Next
	If (toPay = 0) Then
		If (CHECKPERMUTATIONS=False Or checkSolution(coins,allSolutions)) Then 
			allSolutions.addLast(coins)
			If (SHOWCOMBINATIONS) Then
				Local prt:String = ""
				For Local i:Int = 0 To currentSolution.length-1
					prt:+currentSolution[i]+" "
				Next
				Print(prt)
			EndIf
			Return 1
		Else
			Return 0
		EndIf
	ElseIf (toPay < 0) Then
		Return 0
	ElseIf (totalCoins=0) Then
		Return 0
	Else
		Local totalCombinations:Int=0
		For Local i:Int = 0 To coins.length-1
			If (coins[i]>0)
				totalCombinations :+ getPaymentCombos(toPay,coins[..],coinVals,i,currentSolution[..],allSolutions)
			EndIf
		Next
		Return totalCombinations
	EndIf
End Function

Function checkSolution:Int(coins:Int[], allSolutions:TList)
	For Local solution:Int[] = EachIn allSolutions
		Local match:Int = True
		For Local i:Int = 0 To coins.length-1
			If (coins[i]<>solution[i]) Then
				match = False
				i = coins.length
			EndIf
		Next
		If (match=True) Then Return False
	Next
	Return True
End Function